unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FastRGB, FastBMP, FastFX, StdCtrls, Menus, ExtCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Draw1: TMenuItem;
    Filters1: TMenuItem;
    LoadFile1: TMenuItem;
    BmpDraw1: TMenuItem;
    BmpStretch1: TMenuItem;
    BmpTileDraw1: TMenuItem;
    BmpResize1: TMenuItem;
    BmpSmoothResize1: TMenuItem;
    FOpen: TOpenDialog;
    AdjustAttributes1: TMenuItem;
    WaveEffects1: TMenuItem;
    SaveAs1: TMenuItem;
    N1: TMenuItem;
    Revert1: TMenuItem;
    FSave: TSaveDialog;
    Rotate1: TMenuItem;
    SharpenEdges1: TMenuItem;
    AlphaBlending1: TMenuItem;
    N2: TMenuItem;
    Invert1: TMenuItem;
    Emboss1: TMenuItem;
    Flip1: TMenuItem;
    Flop1: TMenuItem;
    Gradient1: TMenuItem;
    FishEye1: TMenuItem;
    Twirl1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure LoadFile1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BmpDraw1Click(Sender: TObject);
    procedure BmpStretch1Click(Sender: TObject);
    procedure BmpTileDraw1Click(Sender: TObject);
    procedure BmpResize1Click(Sender: TObject);
    procedure BmpSmoothResize1Click(Sender: TObject);
    procedure AdjustAttributes1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Revert1Click(Sender: TObject);
    procedure WaveEffects1Click(Sender: TObject);
    procedure Rotate1Click(Sender: TObject);
    procedure SharpenEdges1Click(Sender: TObject);
    procedure AlphaBlending1Click(Sender: TObject);
    procedure Invert1Click(Sender: TObject);
    procedure Emboss1Click(Sender: TObject);
    procedure Gradient1Click(Sender: TObject);
    procedure Flip1Click(Sender: TObject);
    procedure Flop1Click(Sender: TObject);
    procedure FishEye1Click(Sender: TObject);
    procedure Twirl1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Unit2, Unit3, Unit4, Unit5, Unit6, Unit7;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  SetWindowLong(Handle,GWL_EXSTYLE,256 or WS_EX_CLIENTEDGE);
  Width:=Width+1;
  FOpen.InitialDir:=ExtractFilePath(Application.EXEName);
  FSave.InitialDir:=ExtractFilePath(Application.EXEName);
  FOpen.FileName:='fastbmp.bmp';
  FSave.FileName:='fastbmp.bmp';
end;

procedure TForm1.LoadFile1Click(Sender: TObject);
begin
  if FOpen.Execute then
  begin
    FOpen.InitialDir:=ExtractFilePath(FOpen.FileName);
    Form2.Bmp.Free;
    Form2.Buf.Free;
    Form2.Bmp:=TFastBMP.CreateFromFile(FOpen.FileName);
    Form2.Buf:=TFastBMP.CreateCopy(Form2.Bmp);
    Form2.ClientWidth:=Form2.Bmp.Width;
    Form2.ClientHeight:=Form2.Bmp.Height;
    Form2.Caption:=ExtractFileName(FOpen.FileName);
    Form2.Refresh;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Form2.Bmp.Free;
end;

procedure TForm1.BmpDraw1Click(Sender: TObject);
begin
  BmpDraw1.Checked:=True;
  BmpStretch1.Checked:=False;
  BmpTileDraw1.Checked:=False;
  BmpResize1.Checked:=False;
  BmpSmoothResize1.Checked:=False;
  Form2.Style:=0;
  Form2.Refresh;
end;

procedure TForm1.BmpStretch1Click(Sender: TObject);
begin
  BmpDraw1.Checked:=False;
  BmpStretch1.Checked:=True;
  BmpTileDraw1.Checked:=False;
  BmpResize1.Checked:=False;
  BmpSmoothResize1.Checked:=False;
  Form2.Style:=1;
  Form2.Refresh;
end;

procedure TForm1.BmpTileDraw1Click(Sender: TObject);
begin
  BmpDraw1.Checked:=False;
  BmpStretch1.Checked:=False;
  BmpTileDraw1.Checked:=True;
  BmpResize1.Checked:=False;
  BmpSmoothResize1.Checked:=False;
  Form2.Style:=2;
  Form2.Refresh;
end;

procedure TForm1.BmpResize1Click(Sender: TObject);
begin
  BmpDraw1.Checked:=False;
  BmpStretch1.Checked:=False;
  BmpTileDraw1.Checked:=False;
  BmpResize1.Checked:=True;
  BmpSmoothResize1.Checked:=False;
  Form2.Style:=3;
  Form2.Refresh;
end;

procedure TForm1.BmpSmoothResize1Click(Sender: TObject);
begin
  BmpDraw1.Checked:=False;
  BmpStretch1.Checked:=False;
  BmpTileDraw1.Checked:=False;
  BmpResize1.Checked:=False;
  BmpSmoothResize1.Checked:=True;
  Form2.Style:=4;
  Form2.Refresh;
end;

procedure TForm1.AdjustAttributes1Click(Sender: TObject);
begin
  Form3.Show;
end;

procedure TForm1.SaveAs1Click(Sender: TObject);
var
Out: TBitmap;
begin
  if FSave.Execute then
  begin
    FSave.InitialDir:=ExtractFilePath(FSave.FileName);
    Out:=TBitmap.Create;
    Out.Width:=Form2.Bmp.Width;
    Out.Height:=Form2.Bmp.Height;
    Form2.Bmp.Draw(Out.Canvas.Handle,0,0);
    Out.SaveToFile(FSave.FileName);
    Out.Free;
    Form2.Caption:=ExtractFileName(FSave.FileName);
  end;
end;

procedure TForm1.Revert1Click(Sender: TObject);
begin
  Form2.Bmp.Free;
  Form2.Buf.Free;
  Form2.Bmp:=TFastBMP.CreateFromFile(FOpen.FileName);
  Form2.Buf:=TFastBMP.CreateCopy(Form2.Bmp);
  Form2.ClientWidth:=Form2.Bmp.Width;
  Form2.ClientHeight:=Form2.Bmp.Height;
  Form2.Caption:=ExtractFileName(FOpen.FileName);
  Form2.Refresh;
end;

procedure TForm1.WaveEffects1Click(Sender: TObject);
begin
  Form4.Show;
end;

procedure TForm1.Rotate1Click(Sender: TObject);
begin
  Form5.Show;
end;

procedure TForm1.SharpenEdges1Click(Sender: TObject);
begin
  Form6.Show;
end;

procedure TForm1.AlphaBlending1Click(Sender: TObject);
begin
  Form7.Show;
end;

procedure TForm1.Invert1Click(Sender: TObject);
begin
  Invert(Form2.Bmp);
  CopyMemory(Form2.Buf.Bits,Form2.Bmp.Bits,Form2.Buf.Size);
  Form2.Refresh;
end;

procedure TForm1.Emboss1Click(Sender: TObject);
begin
  Emboss(Form2.Bmp);
  CopyMemory(Form2.Buf.Bits,Form2.Bmp.Bits,Form2.Buf.Size);
  Form2.Refresh;
end;

procedure TForm1.Gradient1Click(Sender: TObject);
begin
  InterpolateRect(Form2.Bmp,0,0,Form2.Bmp.Width-1,Form2.Bmp.Height-1,
    FRGB(255,0,0),
    FRGB(255,255,0),
    FRGB(0,0,255),
    FRGB(0,255,0));
  CopyMemory(Form2.Buf.Bits,Form2.Bmp.Bits,Form2.Buf.Size);
  Form2.Refresh;
end;

procedure TForm1.Flip1Click(Sender: TObject);
begin
  Flip(Form2.Bmp);
  CopyMemory(Form2.Buf.Bits,Form2.Bmp.Bits,Form2.Buf.Size);
  Form2.Refresh;
end;

procedure TForm1.Flop1Click(Sender: TObject);
begin
  Flop(Form2.Bmp);
  CopyMemory(Form2.Buf.Bits,Form2.Bmp.Bits,Form2.Buf.Size);
  Form2.Refresh;
end;

procedure TForm1.FishEye1Click(Sender: TObject);
begin
  FishEye(Form2.Buf,Form2.Bmp,1);
  CopyMemory(Form2.Buf.Bits,Form2.Bmp.Bits,Form2.Buf.Size);
  Form2.Refresh;
end;

procedure TForm1.Twirl1Click(Sender: TObject);
begin
  Twist(Form2.Buf,Form2.Bmp,100);
  CopyMemory(Form2.Buf.Bits,Form2.Bmp.Bits,Form2.Buf.Size);
  Form2.Refresh;
end;

end.
